#! /usr/bin/env python2

#Copyright (C) 2013  Denis 'GNUtoo' Carikli <GNUtoo@no-log.org>
#
#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program.  If not, see <http://www.gnu.org/licenses/>.

import dbus
import os
import subprocess
from dbus.mainloop.glib import DBusGMainLoop
DBusGMainLoop(set_as_default=True)

bus = dbus.SystemBus()

usage_obj = bus.get_object('org.freesmartphone.ousaged', '/org/freesmartphone/Usage')
usage_iface = dbus.Interface(usage_obj, 'org.freesmartphone.Usage')

usage_iface.RequestResource("Bluetooth")
usage_iface.RequestResource("CPU")
usage_iface.RequestResource("GPS")


try:
	pid = subprocess.check_output("pidof bluetoothd", shell=True).replace('\n','')
except:
	os.system("bluetoothd")
	pid = subprocess.check_output("pidof bluetoothd", shell=True).replace('\n','')

print "the bluez pid is " + pid

bluez_obj = bus.get_object('org.bluez', "/org/bluez/{0}/hci0".format(pid))
bluez_adapter_iface = dbus.Interface(bluez_obj, 'org.bluez.Adapter')

bluez_adapter_iface.SetProperty("Discoverable", True)

while True:
	try:
		os.system("rfcomm watch /dev/rfcomm0 1 sh -c \"gpspipe -r > /dev/rfcomm0\"")
	except KeyboardInterrupt:
		os.system("killall rfcomm")
		exit(0)
